<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content controller">
                   <div class="content-data">





<ol class="breadcrumb">
  <li>Controllers</li>
  <li>UserController</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/routes/user/user.controller.ts</code>
        </p>

            <p class="comment">
                <h3>Prefix</h3>
            </p>
            <p class="comment">
                <code>user</code>
            </p>





            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#getCustomerId">getCustomerId</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#test">test</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#updateUser">updateUser</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#updateUserArray">updateUserArray</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#updateUserNotificationCredentials">updateUserNotificationCredentials</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getCustomerId"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            getCustomerId
                        </b>
                        <a href="#getCustomerId"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getCustomerId()</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Get()<br /></code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="83"
                            class="link-to-prism">src/routes/user/user.controller.ts:83</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="test"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            test
                        </b>
                        <a href="#test"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>test()</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@Get(&#x27;test&#x27;)<br /></code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="72"
                            class="link-to-prism">src/routes/user/user.controller.ts:72</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateUser"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            updateUser
                        </b>
                        <a href="#updateUser"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateUser()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="86"
                            class="link-to-prism">src/routes/user/user.controller.ts:86</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateUserArray"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            updateUserArray
                        </b>
                        <a href="#updateUserArray"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateUserArray()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="88"
                            class="link-to-prism">src/routes/user/user.controller.ts:88</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateUserNotificationCredentials"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            updateUserNotificationCredentials
                        </b>
                        <a href="#updateUserNotificationCredentials"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateUserNotificationCredentials(response: Response, _id: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, body: literal type)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@UsePipes(new JoiValidationPipe())<br />@Put(&#x27;notification-credentials&#x27;)<br /></code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="92"
                            class="link-to-prism">src/routes/user/user.controller.ts:92</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>response</td>
                                    <td>
                                            <code>Response</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>_id</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>body</td>
                                    <td>
                                            <code>literal type</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">// import Joi from &#x27;joi&#x27;
import * as Joi from &#x27;joi&#x27;
import { Controller, Logger, Get, Put, Body, UsePipes, Headers, Res, Inject } from &#x27;@nestjs/common&#x27;
import { Response } from &#x27;express&#x27;
import { ObjectId } from &#x27;mongodb&#x27;
import { DevicePlatformsEnum, DevicePlatforms } from &#x27;src/models/common/common&#x27;
import { JoiValidationPipe } from &#x27;src/pipes/joi-validation-pipe&#x27;
import { IUserEntityBase, IUserEntityBaseArrayMap, INotificationCredential } from &#x27;src/services/users/models&#x27;
import { UsersService } from &#x27;src/services/users/services/users.service&#x27;
import { ClientProxy } from &#x27;@nestjs/microservices&#x27;
import { MESSAGE_SERVICES } from &#x27;src&#x27;

// const updateUserSchema &#x3D; Joi.object&lt;IUserEntityBase&gt;({
//     // TODO: Implement non-array types here
// })

// const updateUserArraySchema &#x3D; Joi.object&lt;IUserEntityBaseArrayMap&gt;({
//     notification_credentials: Joi.object&lt;INotificationCredential&gt;({
//         device_id: Joi.string()
//             .min(5)
//             .max(100)
//             .required(),
//         notification_token: Joi.string()
//             .min(5)
//             .max(100)
//             .required(),
//         platform: Joi.string()
//             .valid(...Object.keys(DevicePlatformsEnum))
//             .required(),
//     }),
//     // TODO: Implement other array types
// })

interface INotificationCredentialsSchema {
    _id: string
    device_id: string
    notification_token: string
    platform: DevicePlatforms
}

const notificationCredentialsSchema &#x3D; Joi.object&lt;INotificationCredentialsSchema&gt;({
    // _id: Joi.string()
    //     .min(24)
    //     .max(24)
    //     .required(),
    // notification_credentials: Joi.object&lt;INotificationCredential&gt;({
    device_id: Joi.string()
        .min(5)
        .max(100)
        .required(),
    notification_token: Joi.string()
        .min(5)
        .max(300)
        .required(),
    platform: Joi.string()
        .valid(...Object.keys(DevicePlatformsEnum))
        .required(),
    // }),
    // TODO: Implement other array types
})

@Controller(&#x27;user&#x27;)
export class UserController {
    private readonly logger &#x3D; new Logger(UserController.name)

    constructor(
        private readonly usersService: UsersService,
        @Inject(MESSAGE_SERVICES.API_SERVICE) private client: ClientProxy,
    ) { }

    @Get(&#x27;test&#x27;)
    async test() {
        this.logger.debug(&#x27;test&#x27;)
        return this.client.send(
            {
                cmd: &#x27;sum&#x27;,
            },
            [1, 2, 3]
        )
    }

    @Get()
    async getCustomerId() {
    }

    async updateUser() { }

    async updateUserArray() { }

    @UsePipes(new JoiValidationPipe(notificationCredentialsSchema))
    @Put(&#x27;notification-credentials&#x27;)
    async updateUserNotificationCredentials(
        @Res() response: Response,
        @Headers(&#x27;_id&#x27;) _id: string,
        @Body() body: {
            device_id: string
            notification_token: string
            platform: DevicePlatforms
        },
    ) {
        this.logger.debug(this.updateUserNotificationCredentials.name)
        console.log(body)
        console.log(_id)

        const m_id &#x3D; new ObjectId(_id)

        const {
            device_id,
            notification_token,
            platform,
        } &#x3D; body

        // let pairs: &lt;
        //     T extends INotificationCredential,
        //     K extends keyof T
        //     &gt;({
        //         prop: K,
        //         value: T
        //     }) &#x3D;&gt; [] &#x3D; [
        //         {
        //             // array_prop: &#x27;notification_credentials&#x27;,
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id
        //         }
        //     ]

        // let array_filters &#x3D; [
        //     {
        //         prop: &#x27;device_id&#x27;,
        //         value: device_id,
        //     }
        // ]

        // let res &#x3D;
        //     await this.usersService
        //         .updateNotificationCredentials(m_id, {
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id
        //         }, array_filters)

        // let res &#x3D;
        //     await this.usersService
        //         .updateNotificationCredentials(m_id, [{
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id
        //         }, {
        //             prop: &#x27;&#x27;
        //         }], [{
        //             prop: &#x27;device_id&#x27;,
        //             value: device_id,
        //         }])

        let res &#x3D;
            await this.usersService
                .updateNotificationCredentials(m_id, {
                    device_id,
                    notification_token,
                    platform,
                    created: new Date(),
                    updated: new Date(),
                }, {
                    device_id,
                    // notification_token,
                    platform
                })

        response.status(200).send()

        // let res &#x3D;
        //     await this.usersService
        //         .updateUserElementInArray(m_id, pairs, array_filters)

        // let res &#x3D; 
        //     await this.usersService
        //     .updateUserElementInArray(m_id, [
        //         {
        //             array_prop: &#x27;notification_credentials&#x27;,
        //             prop: &#x27;platform&#x27;,
        //             value: &#x27;android&#x27;,
        //         },
        //         {
        //             array_prop: &#x27;notification_credentials&#x27;,
        //             prop: &#x27;device_id&#x27;,
        //             value: &#x27;&#x27;,
        //         },
        //     ], [
        //         {
        //             prop: &#x27;device_id&#x27;,
        //             value: &#x27;&#x27;,
        //         }
        //     ])
        //     // ], [
        //     //     {
        //     //         prop: &#x27;notification_credentials&#x27;,
        //     //         value: {

        //     //         }
        //     //     }
        //     // ])
    }
}
</code></pre>
    </div>
</div>









                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'controller';
            var COMPODOC_CURRENT_PAGE_URL = 'UserController.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
